// Written by Dimitar Kovachev
#include <stdio.h>
#include <time.h>

int Avail[505][505];
int Dirty[505][505];

int Stack[10010];
int st_pos = 0;
inline void Push (int x)
{
	Stack[st_pos] = x;
	++st_pos;
}

int dx[5] = {-1, 0, 1, 0, 0};
int dy[5] = {0, 1, 0, -1, 0};
char names[5] = {'u', 'r', 'd', 'l', '\0'};
int dr[4] = {0, 1, 3, 2};
char filen[2][20] = {"center.1", "center.2"};
int rows, cols, steps, size;
int max_depth;
int cur_best_value;
int cur_best_file;
int cur_version;

inline void UpdateFiles (int val)
{
	if (val <= cur_best_value)
		return;

	cur_best_value = val;
	cur_best_file = !cur_best_file;
	++cur_version;
	FILE *fout = fopen (filen[cur_best_file], "wt");
	for (int i = 0; i < st_pos; ++i)
		if (Stack[i] != 4)
			fprintf (fout, "%c", names[Stack[i]]);
	fprintf (fout, "\n%d\n", cur_version);
	fclose (fout);
}

inline int howMany (int x, int y)
{
	int result = 0;
	for (int i = 0; i < size; ++i)
		for (int j = 0; j < size; ++j)
			if (Dirty[x+i][y+j] == 1)
				++result;
	return result;
}
int greedy1 (int posx, int posy, int more_steps);
int greedy2 (int posx, int posy, int more_steps);
void move (int posx, int posy, int tmp_score, int depth, int last_dir);

int main()
{
	int i, j, k, l, x, y;

	FILE *fin = fopen ("center.inp", "rt");

	cur_best_value = 0;
	cur_best_file = 0;
	cur_version = 0;

	fscanf (fin, "%d%d%d%d", &rows, &cols, &size, &steps);

	for (i = 0; i <= rows+1; ++i)
		for (j = 0; j <= cols+1; ++j)
			Dirty[i][j] = 1;

	for (i = 1; i <= rows - size + 1; ++i)
		for (j = 1; j <= cols - size + 1; ++j)
			Avail[i][j] = 1;

	fscanf (fin, "%d", &k);
	for (l = 0; l < k; ++l)
	{
		fscanf(fin, "%d%d", &x, &y);
		for (i = x-size+1; i <= x; ++i)
		{
			if (i < 0) continue;
			for (j = y-size+1; j <= y; ++j)
			{
				if (j < 0) continue;
				Avail[i][j] = 0;
			}
		}
	}
	fclose (fin);
	if (!Avail[1][1])
	{
		UpdateFiles(1);
		return 0;
	}


	clock_t start = clock();

	greedy1(1, 1, steps);
	greedy2(1, 1, steps);

	clock_t end = clock();
	double GreedyTime = (double)(end - start) / CLOCKS_PER_SEC;
	if (GreedyTime < 0.0000001)
		GreedyTime = 0.0000001;
	double brute = 28.0 / GreedyTime;
	max_depth = 0;
	double tmp_val = 1.0;
	while (tmp_val < brute)
	{
		++max_depth;
		tmp_val *= 4;
		if (max_depth == steps)
			break;
	}
	if (max_depth < steps)
		++max_depth;

	for (i = 1; i <= size; ++i)
		for (j = 1; j <= size; ++j)
			Dirty[i][j] = 10;

	move (1, 1, size * size, 0, 1);

	return 0;
}

int greedy1 (int posx, int posy, int more_steps)
{
	int best_way, best_score, last_way;
	int score, tmp;
	int i, j, st;
	int	t = st_pos;

	score = howMany(posx,posy);
	for (i = 0; i < size; ++i)
		for (j = 0; j < size; ++j)
			if (Dirty[posx+i][posy+j] == 1)
				Dirty[posx+i][posy+j] = 11;

	last_way = 4;

	for (st = 0; st < more_steps; ++st)
	{
		if (Avail[posx+dx[last_way]][posy+dy[last_way]])
			best_way = last_way;
		else best_way = 4;
		best_score = howMany(posx+dx[best_way], posy+dy[best_way]);

		for (i = 0; i <= 3; ++i)
			if (Avail[posx+dx[i]][posy+dy[i]])
			{
				tmp = howMany(posx+dx[i], posy+dy[i]);
				if (tmp > best_score)
				{
					best_score = tmp;
					best_way = i;
				}
			}
		score += best_score;
		Push (best_way);
		posx += dx[best_way];
		posy += dy[best_way];
		for (i = 0; i < size; ++i)
			for (j = 0; j < size; ++j)
				if (Dirty[posx+i][posy+j] == 1)
					Dirty[posx+i][posy+j] = 11;
		last_way = best_way;
	}

	for (i = 0; i <= rows+1; ++i)
		for (j = 0; j <= cols+1; ++j)
			if (Dirty[i][j] == 11)
				Dirty[i][j] = 1;
	UpdateFiles (score);
	st_pos = t;
	return score;
}

int greedy2 (int posx, int posy, int more_steps)
{
	int best_way, best_score, last_way;
	int score, tmp;
	int i, j, st;
	int t = st_pos;

	score = howMany(posx,posy);
	for (i = 0; i < size; ++i)
		for (j = 0; j < size; ++j)
			if (Dirty[posx+i][posy+j] == 1)
				Dirty[posx+i][posy+j] = 12;

	last_way = 4;

	for (st = 0; st < more_steps; ++st)
	{
		if (Avail[posx+dx[last_way]][posy+dy[last_way]])
			best_way = last_way;
		else best_way = 4;
		best_score = howMany(posx+dx[best_way], posy+dy[best_way]);

		for (i = 3; i >= 0; --i)
			if (Avail[posx+dx[i]][posy+dy[i]])
			{
				tmp = howMany(posx+dx[i], posy+dy[i]);
				if (tmp > best_score)
				{
					best_score = tmp;
					best_way = i;
				}
			}
		score += best_score;
		Push (best_way);
		posx += dx[best_way];
		posy += dy[best_way];
		for (i = 0; i < size; ++i)
			for (j = 0; j < size; ++j)
				if (Dirty[posx+i][posy+j] == 1)
					Dirty[posx+i][posy+j] = 12;
		last_way = best_way;
	}

	for (i = 0; i <= rows+1; ++i)
		for (j = 0; j <= cols+1; ++j)
			if (Dirty[i][j] == 12)
				Dirty[i][j] = 1;
	UpdateFiles (score);
	st_pos = t;
	return score;
}


void move (int posx, int posy, int tmp_score, int depth, int last_dir)
{
	int i, j, dir, index, sum;
	int nposx, nposy;

	if (depth == max_depth)
	{
		greedy1(posx, posy, steps-depth);
		greedy2(posx, posy, steps-depth);
		return;
	}

	sum = Avail[posx+1][posy] + Avail[posx-1][posy] + Avail[posx][posy+1] + Avail[posx][posy-1];

	for (index = 0; index < 4; ++index)
	{
		dir = (dr[index] + last_dir) % 4;
		if (index == 3 && sum != 1)
			continue;
		if (Avail[posx+dx[dir]][posy+dy[dir]])
		{
			Push(dir);
			nposx = posx + dx[dir];
			nposy = posy + dy[dir];
			int more = howMany(nposx, nposy);
			for (i = 0; i < size; ++i)
				for (j = 0; j < size; ++j)
					if (Dirty[nposx+i][nposy+j] == 1)
						Dirty[nposx+i][nposy+j] = 100 + depth;

			move (nposx, nposy, tmp_score + more, depth+1, dir);

			for (i = 0; i < size; ++i)
				for (j = 0; j < size; ++j)
					if (Dirty[nposx+i][nposy+j] == 100 + depth)
						Dirty[nposx+i][nposy+j] = 1;
			--st_pos;
		}
	}
}
