#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <setjmp.h>

#define MAX_N 500
#define MAX_M 500
#define MAX_H 10000

#define FREE 0
#define WALL 1

int n, m, l, h;
char ** map;
short int ** map_cov;
int ** lp;
char output[2][20] = { "CENTER.1", "CENTER.2" };
int c_outp, outp_ver;
char path[MAX_H+1]; int p_len;

int cx, cy;
int covered, max_covered;
int max_possible_cov;

jmp_buf j;

void print_output( void )
{
   FILE * f;
   path[p_len] = '\0';

   f = fopen( output[c_outp], "w" );
   fprintf( f, "%s", path );
   fprintf( f, "\n%d", outp_ver++ );
   fclose(f);

   c_outp = 1 - c_outp;

   //////////////////

/*   printf( "%s\n", path );
   printf( "%d %d\n", outp_ver - 1, covered );
   fflush(stdout); */

   /////////////////   
}

void recursia( char fav_dir )
{
   int x, y; char fav_done = 0;
   if ( p_len != h )
   {
      switch ( fav_dir )
      {
      case 'u': goto L_UP; break;
      case 'r': goto L_RIGHT; break;
      case 'd': goto L_DOWN; break;
      case 'l': goto L_LEFT; break;
      default: fav_done = 1; break;
      }
   
L_UP:
      /* UP */
      if ( ( p_len == 0 ) || ( path[ p_len - 1 ] != 'd' ) )
      if ( cy > 0 )
      {
         --cy;
         for ( x = cx; x < cx + l; x++ )
         {
            if ( map[cy][x] == WALL ) goto L2_UP;
            if ( ++map_cov[cy][x] == 1 ) { ++covered; }
         }
         
         path[p_len++] = 'u';
         if ( (y = lp[cy][cx]) < covered )
         {
            lp[cy][cx] = covered;         
            recursia( 'u' );
            lp[cy][cx] = y;
         }
         --p_len;

L2_UP:
         for ( --x; x >= cx; --x )
            if ( --map_cov[cy][x] == 0 ) { --covered; }
         
         ++cy;
      }

      if ( fav_dir == 'u' ) goto L_FAV_DONE;
      /* UP - END */

L_RIGHT:
      /* RIGHT */
      if ( ( p_len == 0 ) || ( path[ p_len - 1 ] != 'l' ) )
      if ( cx + l < m )
      {
         ++cx; x = cx + l - 1;
         for ( y = cy; y < cy + l; y++ )
         {
            if ( map[y][x] == WALL ) goto L2_RIGHT;
            if ( ++map_cov[y][x] == 1 ) { ++covered; }
         }
         
         path[p_len++] = 'r';
         if ( (x = lp[cy][cx]) < covered )
         {
            lp[cy][cx] = covered;         
            recursia( 'r' );
            lp[cy][cx] = x;
         }
         --p_len;

L2_RIGHT:
         x = cx + l - 1;
         for ( --y; y >= cy; --y )
            if ( --map_cov[y][x] == 0 ) { --covered; }
         --cx;
      }
      /* RIGHT - END */

      if ( fav_dir == 'r' ) goto L_FAV_DONE;

L_DOWN:
      /* DOWN */
      if ( ( p_len == 0 ) || ( path[ p_len - 1 ] != 'u' ) )
      if ( cy + l < n )
      {
         ++cy; y = cy + l - 1;
         for ( x = cx; x < cx + l; x++ )
         {
            if ( map[y][x] == WALL ) goto L2_DOWN;
            if ( ++map_cov[y][x] == 1 ) { ++covered; }
         }
         
         path[p_len++] = 'd';
         if ( (y = lp[cy][cx]) < covered )
         {
            lp[cy][cx] = covered;
            recursia( 'd' );
            lp[cy][cx] = y;
         }
         --p_len;

L2_DOWN:
         y = cy + l - 1;
         for ( --x; x >= cx; --x )
            if ( --map_cov[y][x] == 0 ) { --covered; }
         
         --cy;
      }
      
      if ( fav_dir == 'd' ) goto L_FAV_DONE;
      /* DOWN - END */

L_LEFT:
      /* LEFT */
      if ( ( p_len == 0 ) || ( path[ p_len - 1 ] != 'r' ) )
      if ( cx > 0 )
      {
         --cx;
         for ( y = cy; y < cy + l; y++ )
         {
            if ( map[y][cx] == WALL ) goto L2_LEFT;
            if ( ++map_cov[y][cx] == 1 ) { ++covered; }
         }
         
         path[p_len++] = 'l';
         if ( (x = lp[cy][cx]) < covered )
         {
            lp[cy][cx] = covered;
            recursia( 'l' );
            lp[cy][cx] = x;
         }
         --p_len;

L2_LEFT:
         for ( --y; y >= cy; --y )
            if ( --map_cov[y][cx] == 0 ) { --covered; }            
         ++cx;
      }
      if ( fav_dir == 'l' ) goto L_FAV_DONE;
      /* LEFT - END */

L_FAV_DONE:
      if ( !fav_done )
      {
         ++fav_done;
         fav_dir = '\0';
         goto L_UP;
      }
   }
   
   if ( covered > max_covered )
   {
      max_covered = covered;
      print_output();
      
      if ( covered == max_possible_cov ) longjmp(j, 1);
   }
}

int main( void )
{
   int i, k; int x, y;
   FILE * f = fopen( "CENTER.INP", "r" );
   fscanf( f, "%d %d %d %d", &n, &m, &l, &h );
   fscanf( f, "%d", &k );

   map = (char **) malloc( n*sizeof(char *) );
   map_cov = (short int **) malloc( n*sizeof(short int *) );
   lp = (int **) malloc( n*sizeof(int *) );
   
   for ( i = 0; i < n; i++ )
   {
      map[i] = (char *) malloc( m*sizeof(char) );
      memset( map[i], 0, m*sizeof(char) );
      map_cov[i] = (short int *) malloc( m*sizeof(short int) );
      memset( map_cov[i], 0, m*sizeof(short int) );
      lp[i] = (int *) malloc( m*sizeof(int) );
      memset( lp[i], 0, m*sizeof(int) );
   }
   
   max_possible_cov = n*m - k;
   if ( l*(l + h) < max_possible_cov ) max_possible_cov = l*(l + h);
   
   for ( i = 0; i < k; i++ )
   {
      fscanf( f, "%d %d", &y, &x );
      --x; --y;
      map[y][x] = WALL;
      map_cov[y][x] = 0;
   }
   fclose(f);

   for ( y = 0; y < l; y++ )
      for ( x = 0; x < l; x++ )
         map_cov[y][x] |= 1;

   covered = max_covered = l*l;
   lp[0][0] = covered;

   print_output();

   if ( setjmp(j) == 0 )
   {
      cx = 0; cy = 0;
      recursia( 'u' );
   }
   
   for ( i = 0; i < n; i++ )
   {
      free( map[i] );
      free( map_cov[i] );
      free( lp[i] );
   }

   free( lp );
   free( map_cov );
   free( map );

   
   return 0;
}