#include <fstream.h>
#include <assert.h>
#include <process.h>
#include <string.h>
#include <conio.h>
#include <iostream.h>

#define MAXN 610

#define LEFT 1
#define RIGHT 2
#define UP 3
#define DOWN 4

extern int _stklen = 1024 * 1024 * 2;

char mat[MAXN][MAXN];
char vis[MAXN][MAXN];
int  n, m, l, h, k;
int  rightfr[MAXN][MAXN];
int  access[MAXN][MAXN];
int  dist[MAXN][MAXN];
int  pathlen;
int  cleaned[MAXN][MAXN];

int pathy[MAXN*MAXN];
int pathx[MAXN*MAXN];

int ccy[5] = {0, -1, 1, 0, 0};
int ccx[5] = {0, 0, 0, -1, 1};

ofstream fout("center.2");

void readdata()
{
   int      i, y, x;
   ifstream fin("center.inp");

   fin >> n >> m >> l >> h;
   fin >> k;

   for(i=1;i<=k;i++)
   {
      fin >> y >> x;
      mat[y][x] = 1;
   }

   fin.close();
}

void swap(int &a, int &b)
{
   int tmp;

   tmp = a; a = b; b = tmp;
}

void writemat()
{
   int i, j;

   for(i=1;i<=n;i++)
   {
      for(j=1;j<=m;j++)
	if(mat[i][j])
	  cout << "O"; else cout << "x";
      cout << endl;
   }
   cout << endl;
}

void findaccessible()
{
   int i, j, k, fnd;

   for(i=1;i<=n;i++)
   {
      for(j=m;j>=1;j--)
	if(mat[i][j])
	  rightfr[i][j] = 0;
	else
	  rightfr[i][j] = rightfr[i][j+1] + 1;
   }

   for(i=1;i<=n-l+1;i++)
     for(j=1;j<=m-l+1;j++)
     {
	fnd = 1;
	for(k=i;k<=i+l-1;k++)
	  if(rightfr[k][j] < l)
	  {
	     fnd = 0;
	     break;
	  }
	access[i][j] = fnd;
     }

   /*
   for(i=1;i<=n;i++)
   {
      for(j=1;j<=m;j++)
	cout << access[i][j];
      cout << endl;
   }
   */
}

int myabs(int a)
{
   return a < 0 ? -a : a;
}

void writerel(int rel)
{
   switch(rel) {
     case UP: fout << "u"; break;
     case LEFT: fout << "l"; break;
     case RIGHT: fout << "r"; break;
     case DOWN: fout << "d"; break;
   }
}

/*
  returns direction to go from (y1,x1) to (y2,x2)
  1 - l
  2 - r
  3 - u
  4 - d
  0 - no relation
*/
int getrelation(int y1, int x1, int y2, int x2)
{
   if(myabs(x1 - x2) + myabs(y1 - y2) == 1)
   {
      if(x1 == x2)
      {
	 if(y1 < y2) return DOWN;
		else return UP;
      }

      if(y1 == y2)
      {
	 if(x1 < x2) return RIGHT;
		else return LEFT;
      }
   }

   return 0;
}

void bfs(int, int, int, int);
void writecurpath();

void addposition(int y, int x)
{
   int ly, lx;
   assert(access[y][x]);

//   cout << "ADD -> ";  cout << y << " " << x << endl;

   if(pathlen == 0)
   {
      pathlen++;
      pathy[pathlen] = y;
      pathx[pathlen] = x;
      return;
   }

   ly = pathy[pathlen];
   lx = pathx[pathlen];

   if(!getrelation(ly, lx, y, x))
   {
      bfs(ly, lx, y, x);
   }

   pathlen++;
   pathy[pathlen] = y;
   pathx[pathlen] = x;

   if(pathlen == h + 1)
   {
      writecurpath();
      exit(0);
   }
}

// BFS variables
char bfsvis[MAXN][MAXN];
int  predy[MAXN][MAXN];
int  predx[MAXN][MAXN];
int  qy[MAXN*MAXN], qx[MAXN*MAXN];
int  qb, qe;

void bfs(int sy, int sx, int ty, int tx)
{
   int cury, curx, cy, cx, savey, savex;

   swap(sy, ty); // no stack needed
   swap(sx, tx);

//   cout << "BFS\n";
//   cout << sy << " " << sx << " " << ty << " " << tx << endl;

   memset(bfsvis, 0, sizeof(bfsvis));
   qb = qe = 0;

   qy[++qe] = sy;
   qx[qe] = sx;
   bfsvis[sy][sx] = 1;

   while(qb < qe)
   {
      cury = qy[++qb];
      curx = qx[qb];

//      cout << cury << " " << curx << endl;
//      getch();

      for(cy=-1;cy<=1;cy++) for(cx=-1;cx<=1;cx++)
	if(myabs(cx) + myabs(cy) == 1)
	  if(access[cury + cy][curx + cx] && !bfsvis[cury + cy][curx + cx])
	  {
	     bfsvis[cury + cy][curx + cx] = 1;
	     qy[++qe] = cury + cy;
	     qx[qe] = curx + cx;
	     predy[cury + cy][curx + cx] = cury;
	     predx[cury + cy][curx + cx] = curx;

	     if(cury + cy == ty && curx + cx == tx)
	       goto PATH_FOUND;
	  }
   }

   PATH_FOUND:

   cury = ty;
   curx = tx;

   do
   {
      savey = cury; savex = curx;
      cury = predy[savey][savex];
      curx = predx[savey][savex];

//      cout << cury << " - " << curx << endl;
//      getch();
      if(!(cury == ty && curx == tx))
	addposition(cury, curx);
   }
   while(!(cury == sy && curx == sx));
}

void cleanit(int y, int x)
{
   int i, j;

   for(i=y;i<y+l;i++)
     for(j=x;j<x+l;j++)
       if(!cleaned[i][j])
         cleaned[i][j] = 1;
}

int calcdirty(int y, int x)
{
   int i, j, res;

   res = 0;
   for(i=y;i<y+l;i++)
     for(j=x;j<x+l;j++)
       if(!cleaned[i][j])
	 res++;

   return res;
}

int valid(int y, int x)
{
   if((!access[y][x]) || vis[y][x]) return 0;
   return 1;
}

void dfs(int y, int x, int tdist)
{
   int i, j, fnd, dirty, maxdirty;
   int used[5], who;

   if((!access[y][x]) || vis[y][x]) return;

   cleanit(y, x);
   addposition(y, x);

   dist[y][x] = tdist;
   vis[y][x] = 1;

   memset(used, 0, sizeof(used));
   for(i=1;i<=4;i++)
   {
      maxdirty = -1;
      for(j=1;j<=4;j++)
	if(!used[j] && valid(y + ccy[j], x + ccx[j]))
	{
	   dirty = calcdirty(y + ccy[j], x + ccx[j]);
	   if(dirty > maxdirty)
	   {
	      maxdirty = dirty;
	      who = j;
	   }
	}

      if(maxdirty == -1) break;
      used[who] = 1;
      if(maxdirty > 0)
      {
	 assert(calcdirty(y + ccy[who], x + ccx[who]) > 0);
	 dfs(y + ccy[who], x + ccx[who], tdist + 1);
      }
   }
}

void writecurpath()
{
   int i, j;

   for(i=1;i<pathlen;i++)
     writerel(getrelation(pathy[i], pathx[i], pathy[i+1], pathx[i+1]));
   fout << endl;
   fout << 1 << endl;
}

void solveit()
{
   int i, j;

   cleanit(1, 1);
   dfs(1, 1, 0);

   writecurpath();
}

void main()
{
   readdata();
//   writemat();
   findaccessible();
   solveit();
}