#include <stdio.h>
#include <conio.h>

#define RD 'r'
#define LD 'l'
#define UD 'u'
#define DD 'd'

//#define AVAIL 0
#define NAVAIL 1
#define CLEANED 2
#define BUSY 4
#define CANBECLEANED 8

unsigned int N,M,H,L,K;
unsigned long int maxs=0;
unsigned long int maxcleanable=0;
unsigned char moves[10001] = {0};
unsigned char maxmoves[10001] = {0};
unsigned char maze[501][501] = {1};
unsigned char rem[10001][101];  // na h-ta stapka L kvadratcheta

int max(int a, int b)
{
  if (a>b) return a;
  else return b;
}

void input()
{
unsigned int i,j,k,r1,c1;
  FILE *fin=fopen("CENTER.INP","rt");

  fscanf(fin,"%u%u%u%u%u",&N,&M,&L,&H,&K);
  for (i=0;i<K;i++)
  {
	  fscanf(fin,"%u%u",&r1,&c1);
	  maze[r1][c1] |= BUSY;  

	  for (j=max(1,r1-L+1);j <= r1; j++)
		  for (k=max(1,c1-L+1);k <= c1; k++)
			 maze[j][k] |= NAVAIL;   // ne mozhe goren ljav tam
  }
  fclose(fin);
  
  for (j=1; j<=N; j++)
	  for (k=M-L+2; k<=M;k++)
		  maze[j][k] |= NAVAIL;   // ne mozhe goren ljav tam
  for (j=N-L+2; j<=N; j++)
	  for (k=1; k<=M;k++)
		  maze[j][k] |= NAVAIL;   // ne mozhe goren ljav tam

  for (j=1; j<=L; j++)
	  for (k=1; k<=L;k++)
		  maze[j][k] |= CLEANED;   // ne mozhe goren ljav tam

      for (k=0; k<=M;k++)
		  maze[0][k] |= (BUSY | NAVAIL);   // ne mozhe goren ljav tam
      for (k=0; k<=N;k++)
		  maze[k][0] |= (BUSY | NAVAIL);   // ne mozhe goren ljav tam

}

//=============
void findCleanableDFS(unsigned int h1, 
		 unsigned int r1, unsigned int c1)
// dotuk h1 stapki sas s1 izchisteni, v pozicija [r1,c1]
{
unsigned int i,cl;

  if (h1 == H)  
	 {
printf("\nmaxcleanable=%lu\n",maxcleanable);
getch();
	  return;

  }


  if (!(maze[r1][c1+1] & NAVAIL))  //RD
  {
    cl=0;
	for (i=0;i<L;i++)
	{  
        if (!(maze[r1+i][c1+L] & CLEANED)) 
		{
			cl++;
			maze[r1+i][c1+L] |= CLEANED;
		}
		
	};
	if (cl>0) // has new to clean
	{ 
		maxcleanable+=cl;
    	findCleanableDFS(h1+1,r1,c1+1);
	};

  };  // RD
  
  if (!(maze[r1][c1-1] & NAVAIL))  //LD
  {
	cl = 0;
	for (i=0;i<L;i++)
	{  
	    if (!(rem[h1+1][i] & CLEANED)) 
		{
			cl++;
			maze[r1+i][c1-1] |= CLEANED;
		}
	};
    if (cl>0)
	{
		maxcleanable+=cl;
		findCleanableDFS(h1+1,r1,c1-1);
	};

 };  // LD

  if (!(maze[r1+1][c1] & NAVAIL))  //DD
  {
	cl = 0;
	for (i=0;i<L;i++)
	{  
        if (!(rem[h1+1][i] & CLEANED)) 
		{
			cl++;
			maze[r1+L][c1+i] |= CLEANED;
		}
	};
    if (cl>0)
	{
		maxcleanable+=cl;
		findCleanableDFS(h1+1,r1+1,c1);
	}

  };  // DD

  if (!(maze[r1-1][c1] & NAVAIL))  //UD
  {
	cl = 0;
	for (i=0;i<L;i++)
	{  
        if (!(rem[h1+1][i] & CLEANED))
		{
			cl++;
			maze[r1-1][c1+i] |= CLEANED;
		}
	};

    if (cl>0)
	{
		maxcleanable+=cl;
		findCleanableDFS(h1+1,r1-1,c1);
	}

  };  // UD
  

}

//=============

void preDFS()
{
unsigned long int cl=0;
//unsigned int i,j;

maxcleanable = L*L;

findCleanableDFS(0,1,1);

printf("\nmaxcleanable=%lu\n",maxcleanable);

};


void output()
{
FILE *fout;
static unsigned long int w=1;

  if (w % 2) // necheten
    fout=fopen("CENTER.1","wt");
  else //cheten
    fout=fopen("CENTER.2","wt");
  
  maxmoves[H+1]=0;
  fprintf(fout,"%s\n%lu",&maxmoves[1],w);
  fclose(fout);  
  w++;
}

void printmaze()
{
unsigned int i,j;
 
  maxmoves[H+1]=0;
  moves[H+1]=0;
  printf("----- The maze ----- moves=%s ---- maxs=%u ---- maxmoves=%s \n",&moves[1],maxs,&maxmoves[1]);
  for (i=1; i<=N; i++)
  {
	  for (j=1;j<=M; j++)
		  printf(" %u ",maze[i][j]);
	   printf("\n");
  }
  getch();
}

void DFS(unsigned int h1, unsigned long int s1, 
		 unsigned int r1, unsigned int c1)
// dotuk h1 stapki sas s1 izchisteni, v pozicija [r1,c1]
{
unsigned int i,cl;
  if (h1 == H)
  {
	  if (s1 > maxs) 
	  {  
		  maxs=s1;
		  for (i=1; i<=H; i++)
			  maxmoves[i]=moves[i];
		output();
	  };
	return;
  };
if (s1+(H-h1)*L <= maxs) return; // posmartno ne moga da podobrja :)
  
  if (!(maze[r1][c1+1] & NAVAIL))  //RD
  {
	cl = 0;
	for (i=0;i<L;i++)
	{  
		rem[h1+1][i] = maze[r1+i][c1+L];
        if (!(rem[h1+1][i] & CLEANED)) 
		{
			cl++;
		    maze[r1+i][c1+L] |= CLEANED;
		};
	};
    
	moves[h1+1] = RD;
    DFS(h1+1,s1+cl,r1,c1+1);

	for (i=0;i<L;i++)
	{  
		maze[r1+i][c1+L] = rem[h1+1][i];
    };

 };  // RD
  
  if (!(maze[r1][c1-1] & NAVAIL))  //LD
  {
	cl = 0;
	for (i=0;i<L;i++)
	{  
		rem[h1+1][i] = maze[r1+i][c1-1];
        if (!(rem[h1+1][i] & CLEANED)) 
		{
			cl++;
			maze[r1+i][c1-1] |= CLEANED;
		}
	};
    
	moves[h1+1] = LD;
    DFS(h1+1,s1+cl,r1,c1-1);

	for (i=0;i<L;i++)
	{  
		maze[r1+i][c1-1] = rem[h1+1][i];
    };
 };  // LD

  if (!(maze[r1+1][c1] & NAVAIL))  //DD
  {
	cl = 0;
	for (i=0;i<L;i++)
	{  
		rem[h1+1][i] = maze[r1+L][c1+i];
        if (!(rem[h1+1][i] & CLEANED)) 
		{
			cl++;
			maze[r1+L][c1+i] |= CLEANED;
		}
	};
    
	moves[h1+1] = DD;
    DFS(h1+1,s1+cl,r1+1,c1);

	for (i=0;i<L;i++)
	{  
		maze[r1+L][c1+i] = rem[h1+1][i];
    };

 };  // DD

  if (!(maze[r1-1][c1] & NAVAIL))  //UD
  {
	cl = 0;
	for (i=0;i<L;i++)
	{  
		rem[h1+1][i] = maze[r1-1][c1+i];
        if (!(rem[h1+1][i] & CLEANED)) 
		{
			cl++;
			maze[r1-1][c1+i] |= CLEANED;
		}
	};
    
	moves[h1+1] = UD;
    DFS(h1+1,s1+cl,r1-1,c1);

	for (i=0;i<L;i++)
	{  
		maze[r1-1][c1+i] = rem[h1+1][i];
    };

 };  // UD
  

}

void main()
{
  input();
//  printmaze();
  
//  preDFS();
//  printmaze();
  DFS(0,L*L,1,1);
  output();
  
//  printf("That's all folks. \n");
//  getch();
}
