#include <memory.h>
#include <stdio.h>

char* inFileName = "CENTER.INP";
char outFileName[2][10] = { "CENTER.1", "CENTER.2" };

int n, m, l, h;
int a[501][501];
char *steps;
int nsteps, lastActualStep;
int cleaned;

void outputPath() {
	static int version = 0;
	static int maxCleaned = 0;
	if (cleaned > maxCleaned) {
		maxCleaned = cleaned;
		FILE *f = fopen(outFileName[version%2], "wt");
		char c = steps[lastActualStep+1];
		steps[lastActualStep+1] = '\0';
		fprintf(f, "%s\n", steps+2);
		steps[lastActualStep+1] = c;
		fprintf(f, "%d", version);
		fclose(f);
		++version;
	}
}

void clearRow(int r, int c) {
  int i;
  for (i = 0; a[r][c+i] >= 0 && i<l; ++i)
	if (a[r][c+i] == nsteps) { a[r][c+i] = 0; --cleaned; }
  return;
}

void clearCol(int r, int c) {
  int i;
  for (i = 0; a[r+i][c] >= 0 && i<l; ++i)
	if (a[r+i][c] == nsteps) { a[r+i][c] = 0; --cleaned; }
  return;
}

int checkRow(int r, int c) {
  int i, numEmpty = 0;
  for (i = 0; a[r][c+i]>=0 && i<l; ++i)
	if (a[r][c+i] == 0) {
	  ++numEmpty;
	  a[r][c+i] = nsteps;
	}
  if (i == l && numEmpty>0) {
	lastActualStep = nsteps;
    cleaned += numEmpty;
  }
  return (i<l)?-1 : numEmpty;
}

int checkCol(int r, int c) {
  int i, numEmpty = 0;
  for (i = 0; a[r+i][c]>=0 && i<l; ++i)
	  if (a[r+i][c] == 0) {
		  ++numEmpty;
		  a[r+i][c] = nsteps;
	  }
  if (i == l && numEmpty>0) {
	  lastActualStep = nsteps;
	  cleaned += numEmpty;
  }
  return (i<l)?-1 : numEmpty;
}

void searchPath(int r, int c, int cdir) {
  if (nsteps > h) {
	  outputPath();
	  return;
  }
  ++nsteps;
  int savedLastActualStep = lastActualStep;
  for (int d = 0; d < 4; ++d) {
	  switch ((cdir+d)%4) {
	  case 0:
		  if (checkRow(r-1, c) >= 0) {
			  steps[nsteps] = 'u';
			  searchPath(r-1, c, (cdir+d)%4);
		  }
		  clearRow(r-1, c);
		  break;
	  case 1:
		  if (checkCol(r, c-1) >= 0) {
			  steps[nsteps] = 'l';
			  searchPath(r, c-1, (cdir+d)%4);
		  }
		  clearRow(r, c-1);
		  break;
	  case 2:
		  if (checkRow(r+l, c) >= 0) {
			  steps[nsteps] = 'd';
			  searchPath(r+1, c, (cdir+d)%4);
		  }
		  clearRow(r+l, c);
		  break;
	  case 3:
		  if (checkCol(r, c+l) >= 0) {
			  steps[nsteps] = 'r';
			  searchPath(r, c+1, (cdir+d)%4);
		  }
		  clearRow(r, c+l);
		  break;
	  }
  }
  lastActualStep = savedLastActualStep;
  --nsteps;
}

void main(void) {
  FILE* f;
  int i, k, r, c;

  f = fopen(inFileName, "rt");
  setvbuf(f, NULL, _IOFBF, 8192);
  fscanf(f, "%d %d %d %d", &n, &m, &l, &h);
  ++n; ++m;
  steps = new char[h+3];
  memset(a, 0, n*m*sizeof(int));
  for (i = 0; i<=n; ++i) {
	a[i][0] = a[i][m] = -1;
  }
  for (i = 0; i<=m; ++i) {
    a[0][i] = a[n][i] = -1;
  }
  fscanf(f, "%d", &k);
  for (i = 0; i < k; ++i) {
	fscanf(f, "%d %d", &r, &c);
	a[r][c] = -1;
  }
  fclose(f);

  nsteps = lastActualStep = 1;
  for (r = 1; r <= l; ++r)
    for (c = 1; c <= l; ++c) a[r][c] = nsteps;
  cleaned = l*l;
  searchPath(1, 1, 2);

  delete[] steps;
}
