program center;
{$APPTYPE CONSOLE}
uses
  SysUtils;

const INP = 'CENTER.INP';
      OUT1 = 'CENTER.1';
      OUT2 = 'CENTER.2';

type Move = (uu, dd, ll, rr);
     OGR = 0..2;

var N, M, L, H, K, X, Y, BrGreedy, Best, BrOther : Integer;
    A, B : Array[1..500, 1..500] of OGR;
    Moves : Array[1..10010] of Move;
    FF : TextFile;

procedure Init;
  var F : TextFile;
      I, J, X, Y : Integer;
begin
  AssignFile(F, INP);
  Reset(F);
  ReadLn(F, N, M, L, H);
  ReadLn(F, K);
  for I := 1 to K do begin
    ReadLn(F, X, Y);
    A[X, Y] := 1;
    B[X, Y] := 1;
  end;
  for I := 1 to L do
    for J := 1 to L do begin
      A[I, J] := 2;
      B[I, J] := 2;
    end;
  CloseFile(F);
end;

function CheckCorrect(CurX, CurY : Integer; MM : Move) : Integer;
  var I, J, X, Y : Integer;
begin
  X := CurX; Y := CurY;
  case MM of
    ll : Dec(Y);
    rr : Inc(Y);
    uu : Dec(X);
    dd : Inc(X);
  end;
  Result := 0;
  if (X > 0) and (Y > 0) and (X+L-1 <= N) and (Y+L-1 <= M) then begin
    for I := X to X+L-1 do
      for J := Y to Y+L-1 do
        if B[I, J] = 1 then begin
          Result := 0;
          Break;
        end else
        if B[I, J] = 0 then Inc(Result)
  end;
end;

procedure MakeMove(var X, Y : Integer; MM : Move);
  var I, J : Integer;
begin
  case MM of
    ll : Dec(Y);
    rr : Inc(Y);
    uu : Dec(X);
    dd : Inc(X);
  end;
  for I := X to X+L-1 do
    for J := Y to Y+L-1 do begin
      B[I, J] := 2;
    end;
end;

procedure MakeMoveA(X, Y : Integer; MM : Move);
  var I, J, XX, YY : Integer;
begin
  XX := X; YY := Y;
  case MM of
    ll : Dec(YY);
    rr : Inc(YY);
    uu : Dec(XX);
    dd : Inc(XX);
  end;
  for I := XX to XX+L-1 do
    for J := YY to YY+L-1 do begin
      A[I, J] := 2;
    end;
end;

function Max(A, B : Integer) : Integer;
begin
  if A > B then Result := A else Result := B;
end;

function MakeGreedy(C, BB : Integer; var X, Y : Integer) : Integer;
  var F : TextFile;
      A1, A2, A3, A4, I, J, MaxH, Br : Integer;
      Stop : Boolean;
begin
  Br := BB;
  if C = 1 then begin
    Stop := False;
    AssignFile(F, OUT2);
    ReWrite(F);
    repeat
      A1 := CheckCorrect(X, Y, ll);
      A2 := CheckCorrect(X, Y, rr);
      A3 := CheckCorrect(X, Y, uu);
      A4 := CheckCorrect(X, Y, dd);
      MaxH := Max(A1, Max(A2, Max(A3, A4)));
      if MaxH = 0 then Stop := True
      else begin
        Inc(Br);
        if A1=MaxH then begin
          MakeMove(X, Y, ll);
          Write(F, 'l');
        end else
        if A2=MaxH then begin
          MakeMove(X, Y, rr);
          Write(F, 'r');
        end else
        if A3=MaxH then begin
          MakeMove(X, Y, uu);
          Write(F, 'u');
        end else begin
          MakeMove(X, Y, dd);
          Write(F, 'd');
        end;
      end;
    until Stop or (Br >= H);
    WriteLn(F);
    Write(F, 1000);
    CloseFile(F);
    for I := 1 to N do
      for J := 1 to M do begin
        if B[I, J] = 2 then Inc(BrGreedy);
        B[I, J] := A[I, J];
      end;
  end else begin
    Stop := False;
    repeat
      A1 := CheckCorrect(X, Y, ll);
      A2 := CheckCorrect(X, Y, rr);
      A3 := CheckCorrect(X, Y, uu);
      A4 := CheckCorrect(X, Y, dd);
      MaxH := Max(A1, Max(A2, Max(A3, A4)));
      if MaxH = 0 then Stop := True
      else begin
        Inc(Br);
        if A2=MaxH then begin
          MakeMove(X, Y, rr);
{          Write(FF, 'r'); }
          Moves[Br] := rr;
        end else
        if A4 = MaxH then begin
          MakeMove(X, Y, dd);
{          Write(FF, 'd');}
          Moves[Br] := dd;
        end else
        if A1=MaxH then begin
          MakeMove(X, Y, ll);
{          Write(FF, 'l');}
          Moves[Br] := ll;
        end else
        if A3=MaxH then begin
          MakeMove(X, Y, uu);
{          Write(FF, 'u');}
          Moves[Br] := uu;
        end;
      end;
    until Stop or (Br >= H);
    BrOther := 0;
    for I := 1 to N do
      for J := 1 to M do begin
        if B[I, J] = 2 then Inc(BrOther);
        B[I, J] := A[I, J];
      end;
    Result := BrOther;
    if BrOther>Best then begin
      Assign(FF, OUT1);
      ReWrite(FF);
      Best := BrOther;
      for I := 1 to Br do begin
        case Moves[I] of
          uu : Write(FF, 'u');
          dd : Write(FF, 'd');
          ll : Write(FF, 'l');
          rr : Write(FF, 'r');
        end;
      end;
      WriteLn(FF);
      Write(FF, 2000);
      CloseFile(FF);
    end;
  end;
end;

function Count : Integer;
  var I, J : Integer;
begin
  Result := 0;
  for I := 1 to N do
    for J := 1 to M do
      if B[I, J] = 2 then Inc(Result);
end;

procedure MakeOther;
  var StartTime : Double;
      A1, A2, A3, A4, X, Y, Max, Br, ML, MR, MU, MD, XX, YY : Integer;
      Stop : Boolean;
      MZ : Move;
begin
  StartTime := Time;
  Stop := False;
  X := 1; Y := 1;
  Br := 0;
  repeat
    A1 := CheckCorrect(X, Y, ll);
    ML := 0; MU := 0; MR := 0; MD := 0;
    if A1>0 then begin
      Inc(Br);
      Moves[Br] := ll;
      MakeMove(X, Y, ll);
      XX := X; YY := Y;
      if Br < H then ML := MakeGreedy(2, Br, XX, YY) else
        ML := Count;
      Dec(Br); Inc(Y);
    end;
    A2 := CheckCorrect(X, Y, rr);
    if A2>0 then begin
      Inc(Br);
      Moves[Br] := rr;
      MakeMove(X, Y, rr);
      XX := X; YY := Y;
      if Br < H then MR := MakeGreedy(2, Br, XX, YY) else
        MR := Count;
      Dec(Br); Dec(Y);
    end;
    A3 := CheckCorrect(X, Y, uu);
    if A3>0 then begin
      Inc(Br);
      Moves[Br] := uu;
      MakeMove(X, Y, uu);
      XX := X; YY := Y;
      if Br < H then MU := MakeGreedy(2, Br, XX, YY) else
        MU := Count;
      Dec(Br); Inc(X);
    end;
    A4 := CheckCorrect(X, Y, dd);
    if A4>0 then begin
      Inc(Br);
      Moves[Br] := dd;
      MakeMove(X, Y, dd);
      XX := X; YY := Y;
      if Br < H then MD := MakeGreedy(2, Br, XX, YY) else
        MD := Count;
      Dec(Br); Dec(X);
    end;
    if ML > MR then begin
      Max := ML;
      MZ := ll;
    end else begin
      Max := MR;
      MZ := rr;
    end;
    if MU > Max then begin
      Max := MU;
      MZ := uu;
    end;
    if MD > Max then begin
      Max := MD;
      MZ := dd;
    end;
    if Max > 0 then begin
      Inc(Br);
      Moves[Br] := MZ;
      MakeMoveA(X, Y, MZ);
      MakeMove(X, Y, MZ);
    end else Stop := True;
  until (Time-StartTime >= 0.00025) or Stop or (Br=H);
end;

begin
 Init;
 X := 1; Y := 1; BrGreedy := 0;
 MakeGreedy(1, 0, X, Y);
 Best := BrGreedy;
 MakeOther;
end.
