#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>

const int version=1;

using namespace std;

int N,M,L,H,K;

struct point{
	int x,y;
	point():x(0),y(0){};
	point(int X,int Y):x(X),y(Y){}
	point(const point&q):x(q.x),y(q.y){}
	point& operator+=(const point& q){x+=q.x;y+=q.y;return*this;};
	point& operator*=(int n){x*=n;y*=n;return*this;};
};

point moves[4]={point(1,0),point(-1,0),point(0,1),point(0,-1)};
//enum dirs{u,d,r,l};
const int u=0,d=1,r=2,l=3;
char* smoves[4]={"d","u","r","l"}; 

typedef vector<point> points;

//points obstr;

//bool 
int obstr[500][500];//,cleaned[500][500];

const int FORBID=1,CLEAN=2;

//points history;
char history[10000+16];

inline bool canMove(point p,int move){
	int i;
	switch(move){
		case u:
      for(i=0;i<L;i++)
				if(p.x+L==N||(obstr[p.x+L+1][p.y+i]&FORBID))return false;
			break;
		case d:
      for(i=0;i<L;i++)
				if(p.x==0||(obstr[p.x-1][p.y+i]&FORBID))return false;
			break;
		case r:
      for(i=0;i<L;i++)
				if(p.y+L==M||(obstr[p.x+i][p.y+L+1]&FORBID))return false;
			break;
		case l:
      for(i=0;i<L;i++)
				if(p.y==0||(obstr[p.x+i][p.y-1]&FORBID))return false;
			break;
		default:
			return true;
	}
	return true;
}

inline bool isClean(point p,int move){
	int i;
	switch(move){
		case u:
      for(i=0;i<L;i++)
				if(p.x+L==N||(obstr[p.x+L+1][p.y+i]&CLEAN))return true;
			break;
		case d:
      for(i=0;i<L;i++)
				if(p.x==0||(obstr[p.x-1][p.y+i]&CLEAN))return true;
			break;
		case r:
      for(i=0;i<L;i++)
				if(p.y+L==M||(obstr[p.x+i][p.y+L+1]&CLEAN))return true;
			break;
		case l:
      for(i=0;i<L;i++)
				if(p.y==0||(obstr[p.x+i][p.y-1]&CLEAN))return true;
			break;
		default:
			return false;
	}
	return false;
}

inline void setClean(point p,int move){
	int i;
	switch(move){
		case u:
      if(p.x+L<N-1)
			for(i=0;i<L;i++)
				obstr[p.x+L+1][p.y+i]|=CLEAN;
			break;
		case d:
      if(p.x>=1)
      for(i=0;i<L;i++)
				obstr[p.x-1][p.y+i]|=CLEAN;
			break;
		case r:
      if(p.y+L<M-1)
      for(i=0;i<L;i++)
				obstr[p.x+i][p.y+L+1]|=CLEAN;
			break;
		case l:
      if(p.y>=1)
      for(i=0;i<L;i++)
				obstr[p.x+i][p.y-1]|=CLEAN;
			break;
		default:
			;
	}
}

inline int maxMoves(point p,int move){
	int n=0;
	while(canMove(p,move)&&!isClean(p,move))
		p+=moves[move],n++;
	return n;
}

inline bool moveExist(point p){
	for(int i=0;i<4;i++)
		if(maxMoves(p,i)>0)return true;
	return false;
}

inline int min(int a,int b){return a<b?a:b;}

//char backtr[10000+16];

inline point goBack(point p,int &total){
	int i=strlen(history);
	while(--i){
		switch(history[i]){
		case 'u':
			p.x--;//,total++;
			break;
		case 'd':
			p.x++;//,total++;
			break;
		case 'r':
			p.y++;//,total++;
			break;
		case 'l':
			p.y--;//,total++;
			break;
		}
		if(moveExist(p)&&strlen(history)-i+total<N){
			int len=strlen(history),add=len-i;
			total+=add;
			for(i=0;i<add;i++)
				history[len+i]=history[len-i];
			history[i]='\0';
			return p;
		}
	}
	return p;
}


int greedy(){
	history[0]='\0';
	int total=0;
	point p(0,0);
	int next;
	while(total<H){
	BEGIN:
		int max=0,curr=0;
		for(int i=0;i<4;i++){
			curr=maxMoves(p,i);
			if(curr>max)max=curr,next=i;
		}
		//point add(moves[next]);add*=max;
		//p+=add;
		int total0=total;
		if(max==0&&total<H&&total>0){//no more good moves
			p=goBack(p,total);//backtrack over clean squares
			if(total==total0)goto END;//break;
			else goto BEGIN;
		}
		int add=min(max,H-total);
		total+=add;//if(total=
		for(i=0;i<add;i++)
			setClean(p,next),p+=moves[next];
		for(int j=0;j<add;j++)
			strcat(history,smoves[next]);
	}
	END:
	return total;
}

//To do
void random(){
}

//*******************************************
int main(int argc, char **argv){
	FILE* fi=fopen("CENTER.INP","r");
	fscanf(fi,"%d %d %d %d",&N,&M,&L,&H);
	fscanf(fi,"%d",&K);
	//printf("N=%d M=%d L=%d H=%d\n",N,M,L,H);
	int i;
#if 0	
	for(i=0;i<N;i++)
	for(int j=0;i<M;j++)
		obstr[i][j]=FORBID;
#endif
	for(i=0;i<K;i++){
		int x,y;
		fscanf(fi,"%d %d",&x,&y);
		//obstr.push_back(point(x,y));
		obstr[x-1][y-1]=FORBID;
	}
	fclose(fi);
	greedy();
	FILE* fo=fopen("CENTER.1","w");
	fprintf(fo,"%s\n",history);
	fprintf(fo,"%d\n",version);
	fclose(fo);
	printf("history=%s;\n",history);
	return 0;
}